<!DOCTYPE HTML>
<!--
	Theory by TEMPLATED
	templated.co @templatedco
	Released for free under the Creative Commons Attribution 3.0 license (templated.co/license)
-->
<html>
	<head>
		<title>Implémentation</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link rel="stylesheet" href="assets/css/main.css" />
		<link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon">
		<link rel="icon" href="images/favicon.ico" type="image/x-icon">
	</head>
	<body class="subpage">

		<!-- Header -->
		<header id="header">
			<div class="inner">
				<a href="index.html" class="logo">Notre Jeu</a>
				<nav id="nav">
					<a href="idee.html">Idée et conception</a>
					<a href="implementation.html">Implémentation</a>
					<a href="amelioration.html">Futures améliorations</a>
					<a href="compilation.html">Compilation</a>
					<a href="jouer.html">Commment jouer</a>
				</nav>
				<a href="#navPanel" class="navPanelToggle"><span class="fa fa-bars"></span></a>
			</div>
		</header>


		<!-- Main -->
			<section id="main" class="wrapper">
				<div class="inner">
					<header class="align-center">
						<h2>L'implémentation</h2>
						<p>De nombreuses informations sur l'implémentations des fonctionnalitées de ce jeu.</p>
					</header>

				<!-- Content -->
					<h2 id="content">Version de Java et JavaFX</h2>
					<p>Ce projet a été développé à l'aide de la dernière version disponible de Java et JavaFX à l'heure actuelle, la version 14.0</p>

					<br>
					<br>
					<h2 id="content">Un écran divisé en 3 parties</h2>
					<p>L'écran de jeu est divisé en 3 parties : <br>
					La partie haute avec les informations qui sont "bindé" avec les valeurs de jeu, et les boutons de pause et musique qui sont gérées de façon événementielle.<br>
					La partie de droite avec deux panel différents qui se remplacent dans le jeu, les deux étant traité de façon évenementielle.<br>
					La partie au centre avec le jeu qui se met à jour en continue avec la boucle de jeu.<br>
					
					<br><br>

					<h2 id="content">Tout est tuile</h2>
					<p>Quelque soit le type de case, que ce soit une partie du chemin, une tour, un case constructible ou une case non constructible, c'est une tuile.</p>
					
					<br><br>

					<h2 id="content">Système de tuile</h2>
					<p>La carte est basé sur un système de tuile, chaque partie de la carte est stockée comme une tuile, stocké dans une map ayant comme clé la position x et y de la tuile.</p>
					<p>Ce système permet un accès rapide et des modifications rapide d'un élément de la carte.</p>
					
					<br><br>


					<h2 id="content"> Génération de carte et de chemin</h2>
					<p>Pour générer la carte on place d’abord les tuiles constructibles aléatoirement grâce à des proportions, celles-ci sont stockées dans des variables pour permettre à n’importe qui voulant modifier le jeu de les changer facilement, car nous avons rendu le jeu Open-Source. Ensuite on prend aléatoirement une tuile sur colonne de gauche de la carte et une tuile sur celle de droite de la carte. Le chemin devra rejoindre la tuile de gauche pour aller à la tuile de droite. Pour cela, on calcule les valeurs des tuiles environnantes à la tuile où on se trouve. On compare les valeurs des tuiles dans les quatres directions on retiendra la tuile qui à la valeur la plus grande, et qui n’est pas un tuile constructible et qui n’est pas déjà une route, cette valeur est inversement proportionnelle à la distance entre cette tuile et chaque tuile constribles prises en comptes. Notons que les tuiles constructibles sont les seules tuiles à posséder une valeur pour permettre au chemin d’en longer le plus possible. De plus, pour des meilleurs chemins, la valeur compte seulement les tuiles plus à droite de la tuile actuelle. Une fois que l’algorithme à décidé la forme de la tuile à afficher, on réitère l’opération avec la nouvelle tuile jusqu’à la tuile de droite.<br><br> Pour l’affichage de la carte un algorithme spéciale à été développé, tout d’abord un des deux pack de texture est choisi aléatoirement celui-ci sera conservé toute la partie, des nouvelles textures sont implémentables facilement grâce au système actuel, ensuite les cases non-constructibles sont construites façon aléatoire avec un certain ratio min et max,même si le nombre de case minimum peut être inférieur au min en cas de doublon, ce min et max sont des variables pouvant être changé facilement étant donné que ce sont des variables de la classe de génération demap pour une personne voulant modifié le jeu, celui-ci étant open-source. Pour finir, le chemin à des formes différentes et un algorithme dédié compare la position de la case précédente de la case suivante et de l’actuelle afin d’afficher la bonne forme du chemin pour cette case et il fait ça pour toutes les cases</p>
					
					<br><br>

					<h2 id="content"> Les monstres et les attaques</h2>
					<p>Un monstre n'est pas une tuile car il est en déplacement continu, de même pour les attaques. Le chemin des monstres se base sur le chemin pré-construit mais en le linéarisant à une certaine fréquence de pixel dépendant de sa vitessse, des points sont donc rajoutées entre chaque case de son chemin, son chemin est stocké de façon séparé en x et y.<br>
					L'attaque sépare le coté visuel et le coté effet, le programme regarde si les conditions d'attaques sont validées, si c'est le cas, l'attaque fait son effet et l'animation liée est lancée, ceci permet des attaques sur zones et de nombreuses autres apports que les attaques à collisions ne permettent pas.</p>
					
					<br><br>

					<h2 id="content"> L'objet comme principe</h2>
					<p>Ce projet a été développé en pensant objet, comme nous l'avons vu "Tout est tuile" ou presque, il y'a de donc de nombreux niveaux d'héritages notamment pour chaque tour. Nous retrouvons aussi de l'héritage pour les monstres ou les attaques. </p>
					
					<br><br>

					<h2 id="content"> La sauvegarde des données utilisateur et le système anti-triche</h2>
					<p>Quand on quitte le jeu, toutes nos statistiques sont sauvegardées pour que quand le joueur reprenne le jeu, il ne recommence pas de zéro. De nombeux jeux, ne mettent pas de sécurité sur les données sauvegardées, nous avons décidé d’en mettre une grâce à Bcrypt, dans les données sauvegardées une donnée supplémentaire stocke l’ensemble des données de façon encryptée, si le joueur tente de modifier ses données, lors du prochain chargement du jeu, le jeu détectera la modification en comparant les données stockées aux données stockées encryptées et la sauvegarde sera donc perdu. Les paramètres aussi sont sauvegardés et chargés au démarrage du jeu</p>
					
					<br><br>

					<h2 id="content"> Le "Kinds" trick</h2>
					<p>Certaines fonctionnalitées que nous avaons implémentées demandant de connaître le type exact de la classe voulue, il aurait été nécessaire d'effectuer souvent des comparaisons de type de classe, nous avons pour éviter cela implémenté des "TileKinds" et "MonsterKinds" ces énumérations, permettent de façon optimiser et simple de connaître le type exact de l'objet.</p>
					
					<br><br>

					<h2 id="content"> La mise à l'échelle</h2>
					<p>Des échelles de tuiles et d'écrans ont été implémentées, cependant le mode petite tuile n'est utilisable qu'avec le mode petit écran, en cas de sélection d'une autre taille d'écran, le système enregistrera en changeant la taille pour petite. <br>
						Nous vous conseillons les paramètres de bases, les autres versions ayant été moins testées, il y'a plus de chance qu'un bug survienne.
					</p>
				
				</div>
			</section>

		<!-- Footer -->
		<footer id="footer">
			<div class="inner">
				<div class="flex">
					<div class="copyright">
						&copy; Heroes Tower Defense. Design with <a href="https://templated.co">TEMPLATED</a>, made by Jordan Rey-Jouanchicot.
					</div>
				</div>
			</div>
		</footer>

		<!-- Scripts -->
			<script src="assets/js/jquery.min.js"></script>
			<script src="assets/js/skel.min.js"></script>
			<script src="assets/js/util.js"></script>
			<script src="assets/js/main.js"></script>

	</body>
</html>
